// for copying and licensing see the attached file LICENSE.txt; please keep this file with the software
//
#include <stdlib.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include "crt.h"

int termLines = 40;
int termCols = 80;

int queryWinSz(bool prnerr) {
  int res; struct winsize winsz; const char *val;
  res = ioctl(2,TIOCGWINSZ,&winsz);
  //printf("<%i,%i>\n", winsz.ws_row, winsz.ws_col );
  if( res >= 0 ) {
    termLines = winsz.ws_row;
    termCols = winsz.ws_col;
  } else {
    if(prnerr) fprintf(stderr,"error getting screen size for stderr, use env. vars COLUMNS & LINES.\n");
    val = getenv("COLUMNS");
    if(val) { res = atoi(val); if(res>0) termCols = res; }
    val = getenv("LINES");
    if(val) { res = atoi(val); if(res>0) termLines = res; }
  }
  return res;
}

dbl_int get_timediff_ms(struct timespec *begin,struct timespec *end) {
  dbl_int result;
  result = (dbl_int)( end->tv_sec - begin->tv_sec ) * 1000;
  result += ( end->tv_nsec - begin->tv_nsec ) / 1000000;
  return result;
}

