// for copying and licensing see the attached file LICENSE.txt; please keep this file with the software
//
#ifndef SSLCRYPTO_H
#define SSLCRYPTO_H
#include <openssl/evp.h>
//#include <openssl/ssl.h>
#include "basedefines.h"

enum PubKeyFlags { PBK_HAS_TYPE = 1, PBK_ALL_GOOD = 2, PBK_KNOW_KEYSIZE = 4, PBK_HAS_modulo = 8, PBK_HAS_exponent = 16, PBK_HAS_PQG = 32,
  PBK_HAS_Y = 64 };

struct pubkey {
  int type_nid; int flags;
  union {
    struct {
      BIGNUM *modulo;
      int64 exponent;
    } rsa;
    struct {
      BIGNUM *p,*q,*g,*y;
    } dsa;
  } fields;
};

bool parse_pubkey_d( struct pubkey *out,  const uchar *asn1key, int len );
bool parse_pubkey( struct pubkey *out, EVP_PKEY *pubkey );
EVP_PKEY* construct_pubkey(struct pubkey *pbk);
void free_pubkey( struct pubkey *pbk );

bool get_DSA_keysize_p_q(struct pubkey *pbk, int *p, int *q );
int get_keysize(struct pubkey *pbk);

#endif
